#include <iostream>
#include <string>

using namespace std;
#include "UrduSorting.h"


struct Sort{

	wstring word;
	string key;

	bool operator < (Sort str) const
	{
		int x=	key.compare(str.key);
		if(x==0)
		{
			if(word.length()<str.word.length())
				return true;				
		}
		else if(x<0)
				return true;		
			
			return false;
		}
	};


int main(int argc, char* argv[])
{

    if(argc<3 ||strcmp(argv[1],"--help")==0 )
    {
		cout<<"\nThe syntax of the command is incorrect.\n";
		cout<<"\ncollation\tfilename1\tfilename2\n";
		cout<<"filename1: source file name.\n";
		cout<<"filename2: target file name.\n";
        return 1;
    }


	UrduSorting us;

	if (us.Initialize("UrduCollationTable.txt")==false)
	{
		cout<<"\n Initalization failed";
		return 0;
	}
	

	 		    		   
	FileReader fr;
	Sort *sortwords;

	FileReader fr2;
	fr2.Open(argv[1], FileReader::UNI);

	wstring wcount,wtemp;
	int count;
	fr2.GetLine(wcount,7,'\n');
	count = wstring2int(wcount);

	sortwords = new Sort[count];
	
	int i=0;

	while(!fr2.EoF()&&i<count)
	{

		fr2.GetLine(wtemp,15,'\n');

		sortwords[i].word = wtemp;
		sortwords[i].key = us.GetCollationKey(sortwords[i].word,3);
		i++;
	}

	sort(sortwords,sortwords+count);

	FileWriter fw;
	fw.Open(argv[2], FileWriter::UNI);

	wchar_t endline[2] = {13,10};
	for(i=0; i<count; i++)
	{
		fw.Write(endline,2);
		fw.Write(sortwords[i].word);
	}

	fr2.Close();
	fw.Close();
	return 0;
}
